<?php
$res = run_query('SHOW COLUMNS FROM ' . $config['table_prefix'] . 'calc LIKE "expert_mode"');
if (!sql_num_rows($res)) {
    $sql = 'ALTER TABLE ' . $config['table_prefix'] . 'calc ADD expert_mode tinyint(1) NOT NULL DEFAULT 1;';
    run_query($sql);
} else {
    $sql = 'ALTER TABLE ' . $config['table_prefix'] . 'calc ALTER expert_mode SET DEFAULT 1;';
    run_query($sql);
}

$sql = 'CREATE TABLE IF NOT EXISTS `' . $config["table_prefix"] . 'calc_template` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `name` varchar(255) NOT NULL,
    `calculate_tpl` longtext NOT NULL,
    `params` longtext NOT NULL,
    PRIMARY KEY (`id`)
    ) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
';
run_query($sql);

run_query('DELETE FROM ' . $config["table_prefix"] . 'calc_template');

$sql_query = <<<EOF
INSERT INTO {$config["table_prefix"]}calc_template (id, name, calculate_tpl, params) VALUES
(1,	'Сумма из подтаблицы в основную запись',	'if (\$line[\$params[''gen_field''][''link_field_id'']][''raw''] > 0) {\r\n    if (\$event[''type''] == ''delete'') {\r\n        \$sql = '' AND id <> '' . \$ID;\r\n    }\r\n    \$result = data_select_field(\$table_id, \"sum({\$params[''cur_field'']}) as f_sum\", \"status = 0 AND {\$params[''gen_field''][''link_field_id'']} = \" . \$line[\$params[''gen_field''][''link_field_id'']][''raw''] . \$sql);\r\n    \$row = sql_fetch_assoc(\$result);\r\n    \$line[\$params[''gen_field''][''link_field_id'']][\$params[''gen_field''][''field'']] = \$row[''f_sum''];\r\n}',	'{\r\n    "title": "Сумма из подтаблицы в основную запись",\r\n    "help": "Данный шаблон подтягивает сумму по числовому полю подтаблицы в основную запись",\r\n    "parameters": {\r\n        "cur_field": {\r\n            "type": "Field",\r\n            "name": "cur_field",\r\n            "description": "Выберите поле, по которому считать сумму",\r\n            "type_field": 1\r\n        },\r\n        "gen_field": {\r\n            "type": "TableField",\r\n            "name": "gen_field",\r\n            "description": "Выберите основную таблицу",\r\n            "field_description": "Выберите поле, в которое подтягивать сумму",\r\n            "only_parent": true,\r\n            "type_field": 1\r\n        }\r\n    }\r\n}'),
(2,	'Заполнение поля значением другого',	'if (!\$line[\$params[''cur_field1'']]) {\r\n    \$line[\$params[''cur_field1'']] = \$line[\$params[''cur_field2'']];\r\n}',	'{\r\n    "title": "Заполнение поля значением другого",\r\n    "help": "Данный шаблон заполняет одно поле значением другого, в том случае если первое поле не было заполнено",\r\n    "parameters": {\r\n        "cur_field1": {\r\n            "type": "Field",\r\n            "name": "cur_field1",\r\n            "description": "Выберите поле-получатель"\r\n        },\r\n        "cur_field2": {\r\n            "type": "Field",\r\n            "name": "cur_field2",\r\n            "description": "Выберите поле-источник"\r\n        }\r\n    }\r\n}'),
(3,	'Добавление к дате дней',	'\$line[\$params[''cur_field3'']] = date(''Y-m-d H:i:s'', strtotime(\$line[\$params[''cur_field1'']]) + \$line[\$params[''cur_field2'']] * 3600 * 24);',	'{\r\n    "title": "Добавление к дате дней",\r\n    "help": "Данный шаблон добавляет к значению даты из первого поля указанное число дней из второго поля и вставляет результат в третье поле",\r\n    "parameters": {\r\n        "cur_field1": {\r\n            "type": "Field",\r\n            "name": "cur_field1",\r\n            "description": "Выберите исходную дату",\r\n            "type_field": [\r\n                2,\r\n                12\r\n            ]\r\n        },\r\n        "cur_field2": {\r\n            "type": "Field",\r\n            "name": "cur_field2",\r\n            "description": "Выберите поле с числом дней",\r\n            "type_field": 1\r\n        },\r\n        "cur_field3": {\r\n            "type": "Field",\r\n            "name": "cur_field3",\r\n            "description": "Выберите поле для записи результата",\r\n            "type_field": 2\r\n        }\r\n    }\r\n}'),
(4,	'Значение по умолчанию',	'if (\$event[''is_new_line'']) {\r\n    \$line[\$params[''cur_field'']] = \$line[\$params[''gen_field''][''link_field_id'']][\$params[''gen_field''][''field'']];\r\n}',	'{\r\n    "title": "Значение по умолчанию",\r\n    "help": "",\r\n    "parameters": {\r\n        "cur_field": {\r\n            "type": "Field",\r\n            "name": "cur_field",\r\n            "description": "Выберите поле, в которое подставлять значение",\r\n            "no_system": true\r\n        },\r\n        "gen_field": {\r\n            "type": "TableField",\r\n            "name": "gen_field",\r\n            "description": "Выберите основную таблицу",\r\n            "field_description": "Выберите поле, из которого тянуть значение",\r\n            "only_parent": "true"\r\n        }\r\n    }\r\n}'),
(5,	'Заполнение поля из поля связи',	'\$line[\$params[''cur_field'']] = \$line[\$params[''gen_field''][''link_field_id'']][\$params[''gen_field''][''field'']];',	'{\r\n    "title": "Заполнение поля из поля связи",\r\n    "help": "Данный шаблон заполняет поле значением из поля связи",\r\n    "parameters": {\r\n        "cur_field": {\r\n            "type": "Field",\r\n            "name": "cur_field",\r\n            "description": "Выберите поле, в которое сохранять значение",\r\n            "no_system": true\r\n        },\r\n        "gen_field": {\r\n            "type": "TableField",\r\n            "name": "gen_field",\r\n            "description": "Выберите таблицу, из которой тянуть значение",\r\n            "field_description": "Выберите поле, из которого тянуть значение",\r\n            "only_parent": "true"\r\n        }\r\n    }\r\n}');
EOF;
run_query($sql_query);