<?php
global $lang;
// создаем таблицу вычислений
// replace_ID - переходный вариант, для вычислений которые содержат, старый формат {ID}
run_query("CREATE TABLE `" . $config["table_prefix"] . "calc` (`id` int(11) NOT NULL AUTO_INCREMENT, `table_id` int(11) NOT NULL, `name` varchar(255) character set utf8 collate utf8_general_ci NOT NULL, `calculate` text character set utf8 collate utf8_general_ci NOT NULL, old_format int(11) NOT NULL, `link_fields` text CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,  PRIMARY KEY (`id`), KEY `table_id` (`table_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1");

// Типы событий
// 1 - сохранение в таблице, параметр id таблицы
// 2 - просмотр поля, параметр id поля
// 3 - изменение поля, параметр id поля
// 4 - удаление в таблице, параметр id таблицы
//     позволяет отменить действие через параметр
//       global $cancel_delete;
//       $cancel_delete=1;
// 5 - импорт в таблице, параметр id таблицы
// 6 - архивирование в таблице, параметр id таблицы
// 10 - удаление файла, параметр id файла
// 11 - добавление файла, параметр id файла
// 13 - загрузка файла, параметр id файла
// 24 - нажатие на кнопку (доп. действие), параметр id допдействия
// Также могут быть в будущем добавлены другие события - например
// 16 - логин пользователся, параметр id пользователя
// 17 - выход пользователя (logout)
run_query("CREATE TABLE `" . $config["table_prefix"] . "calc_cond` (`calc_id` int(11) NOT NULL, `type` int(11) NOT NULL, `param` int(11) NOT NULL, `param2` int(11) NOT NULL, INDEX ( `calc_id` )) ENGINE = MYISAM");

// выбираем все текущие вычисления в таблицах
$result = run_query("SELECT * FROM " . $config["table_prefix"] . "tables WHERE calculate!=''");
while ($row = mysqli_fetch_array($result)) { // Выбираем текущие вычисления в таблицах
    $table_id = $row['id'];
    $calc = $row['calculate'];
    // Заменяем стандартные конструции ID
    $calc = str_replace('"id={ID}"', '"id=\'$ID\'"', $calc);
    if (strpos($calc, '{ID}')) {
        $old_format = 1;
    } else {
        $old_format = 0;
    }
    $calc = addslashes($calc);
    $name = addslashes($lang["Save_in_table"]);
    run_query("INSERT INTO `" . $config["table_prefix"] . "calc` (`table_id`, `name`, `calculate`, `old_format`) VALUES ('$table_id', '$name', '$calc','$old_format')");
    $calc_id = mysqli_insert_id($sql_global_link);
    run_query("INSERT INTO `" . $config["table_prefix"] . "calc_cond` (`calc_id`, `type`, `param`) VALUES ('$calc_id', '1', '$table_id')"); // СОХРАНЕНИЕ
    run_query("INSERT INTO `" . $config["table_prefix"] . "calc_cond` (`calc_id`, `type`, `param`) VALUES ('$calc_id', '5', '$table_id')"); // ИМПОРТ
}
// удаляем старое поле
run_query("ALTER TABLE `" . $config["table_prefix"] . "tables` DROP `calculate`");
// выбираем все текущие вычисления в таблицах
$result = run_query("SELECT * FROM " . $config["table_prefix"] . "fields WHERE calculate!=''");
while ($r_field = mysqli_fetch_array($result)) { // Выбираем текущие вычисления в таблицах
    $field_id = $r_field['id'];
    $table_id = $r_field['table_id'];
    $calc = $r_field['calculate'];
    $calc = f_quotes($calc);
    if (strpos($calc, '{ID}')) {
        $old_format = 1;
    } else {
        $old_format = 0;
    }
    $calc = str_replace('return $value;' . "\n", '', $calc);
    $calc = str_replace('return $value;' . "\r\n", '', $calc);
    $calc = str_replace('return $value;', '', $calc);
    $calc = f_return($calc, '$line[\'' . form_int_name($field_id) . '\']=');
    $calc = str_replace('$value', '$line[\'' . form_int_name($field_id) . '\']',
        $calc); // Переменная $value теряет смысл, т.к. отсутсвует понятие вычисляемое поле

    if ($calc) {  // если вычисление не состояло только из return $value
        $calc = addslashes($calc);
        $name = addslashes($lang["Show_field"] . ": " . $r_field['name_field']);
        run_query("INSERT INTO `" . $config["table_prefix"] . "calc` (`table_id`, `name`, `calculate`, `old_format`) VALUES ('$table_id','$name', '$calc', '$old_format')");
        $calc_id = mysqli_insert_id($sql_global_link);
        run_query("INSERT INTO `" . $config["table_prefix"] . "calc_cond` (`calc_id`, `type`, `param`) VALUES ('$calc_id','2', '$field_id')");
    }
    // меняем само поле, если это текстовое поле, ставим флажок - выводить как html
    if ($r_field['type_field'] == 3) {
        $type_value = "{view_html}\r\n" . $r_field["type_value"];
        run_query("UPDATE " . $config["table_prefix"] . "fields SET `type_value`='" . addslashes($type_value) . "' WHERE id='$field_id'");
    }
}
run_query("ALTER TABLE `" . $config["table_prefix"] . "fields` DROP `calculate`");

// Создаем таблицу логов
run_query("CREATE TABLE IF NOT EXISTS `" . $config["table_prefix"] . "logs` (`id` int(11) NOT NULL AUTO_INCREMENT, `date` datetime NOT NULL, `text` text CHARACTER SET utf8 NOT NULL, `user_id` int(11) NOT NULL, `crc` blob NOT NULL, PRIMARY KEY (`id`)) ENGINE=MyISAM AUTO_INCREMENT=1");

run_query("INSERT INTO `" . $config["table_prefix"] . "config` (`key`, `value`) VALUES ('log_changed','1')"); // Логируем изменения в базе
run_query("INSERT INTO `" . $config["table_prefix"] . "config` (`key`, `value`) VALUES ('log_login','1')");   // Логируем логины
run_query("INSERT INTO `" . $config["table_prefix"] . "config` (`key`, `value`) VALUES ('vlm','2')");   // Теперь только табличный вид подтаблиц

// -------------Замена return  ---------------
function f_return($calc, $rp)
{
    // Заменяем все return, которые не внутри function
    for ($i = 0; $i < strlen($calc); $i++) {
        if ($calc[$i] == '{') {
            $kav++;
        }
        if ($calc[$i] == '}') {
            $kav--;
            if ($kav == 0) {
                $is_function = 0;
            }
        }
        if (substr($calc, $i, strlen('function ')) == 'function ') { // есть переменная
            $is_function = 1;
        }
        if (substr($calc, $i, strlen('return ')) == 'return ') { // есть переменная
            $is_return = $i;
        }
        if (($calc[$i] == ';') && ($is_return)) { // есть переменная
            $ret_len = $i - $is_return;
            $calc = substr($calc, 0, $is_return) . $rp . substr($calc, $is_return + strlen('return '), strlen($calc));
            $i = $is_return + strlen($rp);
            $is_return = 0;
        }
    };
    return $calc;
}

// ============ Замена return  ===============

// ------------- Замена {ID} на $ID -------------
function replace_id($obl)
{
    $replace = '$ID';
    $i = 0;
    $count = substr_count($obl, '{ID}');//находим колво {ID}
    while ($count > 0) {
        $target = strpos($obl, '{ID}'); //находим очередную позицию {ID}
        $mobl[$i] = substr($obl, 0, $target + 4);//строка до {ID}
        $end[$i] = substr($obl, $target + 4, 1);//символ после {ID}
        $pattern = '/[a-zA-Z0-9]/';//паттерн для символа после {ID}
        if (!preg_match($pattern, $end[$i]))//если символ после {ID} не соответствует паттерну
        {
            $getid = substr($mobl[$i], $target); //находим {ID}
            $mobl[$i] = str_replace($getid, $replace, $mobl[$i]);
        }
        $obl = substr($obl, $target + 4);
        $count--;
        $i++;
    }
    $mobl[] = $obl;
    $nobl = implode('', $mobl);
    return $nobl;
}

function aslh($str, $quote)
{
    $tgsabs = strpos($str, $quote); //находим позицию '
    $str2 = $str;
    while (substr($str, $tgsabs - 1, 1) == '\\') {
        $str2 = substr($str, $tgsabs + 1);
        $tgs = strpos($str2, $quote); //находим позицию "
        $tgsabs = $tgsabs + $tgs + 1;
    }
    return $tgsabs;
}

function f_quotes($str)
{
    $ii = 0;
    while (strlen($str) > 0) {
        if (substr_count($str, '"') > 0) //наличие "
        {
            if (substr_count($str, "'") > 0) //наличие ' ,
            {
                $tgs = aslh($str, "'"); //находим позицию '
                $tgd = aslh($str, '"'); //находим позицию "

                if ($tgd < $tgs) //обрабатываем внутри "
                {
                    $kq = 1;
                    while ($kq < 3) {
                        $tg = aslh($str, '"'); //находим позицию "

                        $a = substr($str, 0, $tg + 1); //$a = все до "
                        $str = substr($str, $tg + 1);//обрезаем строку левее " включительно
                        if ($kq % 2 == 0) {
                            $a = replace_id($a);
                        }
                        $new[$ii] = $a;
                        $kq++;
                        $ii++;
                    }
                } elseif ($tgd > $tgs) {
                    $kq = 1;
                    while ($kq < 3) {
                        $tg = aslh($str, "'"); //находим позицию '

                        $a = substr($str, 0, $tg + 1); //$a = все до '
                        $str = substr($str, $tg + 1);//обрезаем строку левее ' включительно
                        $kq++;
                        $new[$ii] = $a;
                        $ii++;
                    }
                }
            } else {
                $done = replace_id($str);//если нет '
                $new[$ii] = $done;
                $str = '';
                $ii++;
            }
        } else {
            $new[$ii] = $str; //если нет "
            $str = '';
            $ii++;
        }
    }
    $newstring = implode('', $new);
    return $newstring;
}

// ============= Замена {ID} на $ID =============
?>