import { ApiComponent } from "./api/ApiComponent.js?revision=22410";
import { AccessComponent } from "./access/AccessComponent.js?revision=22410";
import { ChannelsComponent } from "./channels/ChannelsComponent.js?revision=22410";
import { EditChannel } from "./channels/EditChannel.js?revision=22410";
import { CurrentSelectedTable } from "./channels/CurrentSelectedTable.js?revision=22410";
import { AdditionallyComponent } from "./additionally/AdditionallyComponent.js?revision=22410";

/**
 * Компоненты, которые скорее всего не изменятся
 */

const IconComponent = {
  name: `icon-component`,
  props: ['transport'],
  template: /*html*/`
    <template v-if="transport == 'instagram'">
      <img src="stocks/images/instagram.svg" />
    </template>

    <template v-else-if="transport == 'tgapi'">
      <img src="stocks/images/telegram.svg" />
    </template>

    <template v-else>
      <img src="stocks/images/whatsapp.svg" />
    </template>
  `
}

const SaveButton = {
  name: 'save-button',
  emits: ['clickHandle'],
  template: /*html*/`
    <div style="text-align: center;">
      <button
        class="btn btn-default"
        @click="$emit('clickHandle')"
      >{{ $t('Save') }}</button>
    </div>
  `
}

export const components = [
  SaveButton,
  IconComponent,

  ApiComponent,
  AccessComponent,
  AdditionallyComponent,
  ChannelsComponent,
  EditChannel,
  CurrentSelectedTable
]
