const { inject, ref, onMounted } = Vue;

export const CaptionComponent = {
  props: ['block_name'],

  setup(props, {emit}) {
    const block_name = inject('block_name');
    const caption    = inject('caption');
    const report_id  = inject('report_id');

    return {
      caption,

      buildCheckboxIdent() {
        return `checkbox_${block_name}`;
      },

      clickHandle() {
        toggleCollapseEntity(report_id, block_name);
      }
    }
  },

  template: /*html*/`
    <input type="checkbox" :id="buildCheckboxIdent()" class="caption_checkbox">
    <label :for="buildCheckboxIdent()" @click="clickHandle">{{ caption }}</label>
  `
}
