import { CellViewComponent } from "./CellViewComponent.js";


const { inject, ref, onMounted } = Vue;


export const TableComponent = {
  props: ['rows'],
  components: {
    'cell-view-component': CellViewComponent
  },

  setup(props, {emit}) {
    const alignment  = inject('alignment');
    const columns    = inject('columns');

    onMounted(_ => setTimeout(() => $('.repconview__table_table').fixedTable(), 500));

    return {
      alignment,
      columns,
    };
  },

  template: /*html*/`
    <table
      v-if='rows.length > 0'
      class="repconview__table_alignment_center"
      style="overflow: hidden;"
      id="table_SRC2_RowSet"
      table_id="43"
    >
      <thead>
        <tr>
          <template v-for='column in columns'>
            <th
              v-if='column.hidden'
            >{{ column.column_title }}</th>
          </template>
        </tr>
      </thead>

      <tbody>
        <tr v-for='row in rows'>
          <template v-for='column in columns'>
            <td
              v-if='column.hidden'
              :style="'text-align:'+ alignment"
            >
              <cell-view-component :column="column" :row="row" />
            </td>
          </template>
        </tr>
      </tbody>
    </table>
  `
}
