import { App } from "./App.js";

/**
 * Сформировать компонент блока поиска.
 *
 * @param {Object} ko_settings  Настройки блока
 */
export default async function(ko_settings) {
  // console.log(ko_settings);

  const block_id   = ko_settings?.block_id || 0;
  const block_name = ko_settings?.block_name || '';
  const caption    = ko_settings?.caption || lang['Search'];
  const table_id   = ko_settings?.table_id || 0;
  const use_links  = ko_settings?.use_links || 'implicit';
  const sort       = ko_settings?.sort || '';
  const limit      = ko_settings?.limit || 50;
  const alignment  = ko_settings?.alignment || 'center';
  const statuses   = ko_settings?.statuses || '';
  const columns    = ko_settings?.columns || [];
  const cut_to     = ko_settings?.cut_to || 0;

  const params_from_url = new URLSearchParams(window.location.search);
  const report_id = params_from_url.get('id');

  Vue.createApp(App)
    .provide('block_id',   block_id)
    .provide('block_name', block_name)
    .provide('caption',    caption)
    .provide('table_id',   table_id)
    .provide('use_links',  use_links)
    .provide('sort',       sort)
    .provide('limit',      limit)
    .provide('alignment',  alignment)
    .provide('statuses',   statuses)
    .provide('columns',    columns)
    .provide('cut_to',     cut_to)
    .provide('report_id',  report_id)
    .mount(`#${block_name}`);

  window['search_block_values'] = typeof window['search_block_values'] === 'undefined'
    ? [] : window['search_block_values'];

  window['report_search_blocks'] = typeof window['report_search_blocks'] === 'undefined'
    ? {} : window['report_search_blocks'];

  window['report_search_blocks'][block_name] = typeof window['report_search_blocks'][block_name] === 'undefined'
    ? ko_settings : window['report_search_blocks'][block_name];
}
