export default {
    data() {
        return {
            fieldTypes: { file: 6 , image: 9 }
        }
    },

    props: ["fields", "table", "cardId"],

    template: `<template v-for="field of fields">
        <div
            v-if="field.field_id !== null"
            :class="{'main-users_carts-content-items--text': true,'itemsHidden':field.hidden}"
        >
            <template
                v-if="field.name"
            >{{ field.name }}: </template>

            <template
                v-if="field.type_field != fieldTypes.file && field.type_field != fieldTypes.image"
            >
                <template v-for="item of field.value">{{ item }}</template>
            </template>
            <div v-else-if="field.type_field == fieldTypes.file">
                <fileFields
                    :table="table"
                    :id="cardId"
                    :field="field"
                />
            </div>
            <div v-else>
                <imageFields
                    :table="table"
                    :id="cardId"
                    :field="field"
                />
            </div>
        </div>
    </template>`
}
