$(document).ready(reportOnReady);

function reportOnReady() {
  if(window.parent) {
    window.parent.postMessage(document.getElementsByTagName("html")[0].scrollHeight, "*");
  }

  if($('body').width() > 990) {
    $('.repconview__layout').prepend(create_preloader_block());
  }

  init_report_script();
  additionalReportOptions();
}

function showAAUpdatedLines() {
  let aa_table = JSON.parse($.cookie('aa_table') || '{}');

  if (Object.keys(aa_table).length != 0 && aa_table.table_id.length > 0) {
    $('[table_id='+(aa_table.table_id)+']').find('tr').each((i, el) => {
      if (aa_table.sels.includes(parseInt($(el).attr('line_id')))) {
        $(el).css('background-color', '#fff6ad');
        setTimeout(() => {
          $(el).css('background-color', '');
        }, 2000);
      }
    });
  }

  $.removeCookie('aa_table');
}

// Изображение при переключении периодов
function add_img_update(element) {
  element.each((i, el) => {
    if ($(el).hasClass('repconview__caption-params-info-updated')) {
      // $(el).attr('src', 'images/report-parameters_update.svg');
      let parentBlock = $(el).closest('.repconview__indicator_one_third'); // Для блочных показателей
      let parentTable = $(el).closest('.table_div_container'); // Для табличных показателей
      if (parentBlock) {
        parentBlock.find('.repconview__indicator_one_third__body a').addClass('repconview__indicator-value_updated');
        parentBlock.find('.repconview__indicator_one_third__body span').addClass('repconview__indicator-value_updated');
      }
      if (parentTable) {
        parentTable.find('.repconview__table_table td span').addClass('repconview__indicator-value_updated');
      }
    };
  });
};

function remove_indicator_update(element) {
  let parentBlock = element.closest('.repconview__indicator_one_third'); // Для блочных показателей
  let parentTable = element.closest('.table_div_container'); // Для табличных показателей

  if (parentBlock) {
    parentBlock.find('.repconview__indicator_one_third__body a').addClass('repconview__indicator-value_default');
    parentBlock.find('.repconview__indicator_one_third__body span').addClass('repconview__indicator-value_default');
  }
  if (parentTable) {
    parentTable.find('.repconview__table_table td span').addClass('repconview__indicator-value_default');
  }
}

function remove_class_update(element) {
  element.each(function(i, el) {
    if($(window).scrollTop() + $(window).height() >= $(el).offset().top && $(el).hasClass('repconview__caption-params-info-updated')) {
      setTimeout(() => {
        $(el).removeClass('repconview__caption-params-info-updated');
        // $(el).attr('src', 'images/report-parameters.svg');
        remove_indicator_update($(el));
      }, 750);
    }
  });
};

function copyToShare(link){
  var tmp = $("<textarea id='share' style='position: absolute; top:-1000px'>");
  $("body").append(tmp);
  $('#share').val(link).select();
  document.execCommand("copy");
  displayNotification(lang['Link_copied'], 1);
};

function remove_class_update_for_scroll(element) {
  $(window).scroll(function() {
    element.each((i, el) => {
      if($(window).scrollTop() + $(window).height() >= $(el).offset().top && $(el).hasClass('repconview__caption-params-info-updated')) {
        // setTimeout(() => {
        $(el).removeClass('repconview__caption-params-info-updated');
        // $(el).attr('src', 'images/report-parameters.svg');
        remove_indicator_update($(el));
        // }, 1000);
      }
    });
  });
}

function toggleCollapseEntity(report_id, entity_id){
  let collapsed_items = JSON.parse($.cookie('cb_reports_collapsed') ?? '{}');

  let collapsed_entities_set = new Set(collapsed_items[report_id] ? (collapsed_items[report_id]['entities'] ?? []) : []);

  if(!!$('#checkbox_' + entity_id).prop('checked')){
    collapsed_entities_set.delete(entity_id);
  }
  else {
    collapsed_entities_set.add(entity_id);
  }

  collapsed_items[report_id] = {
    timestamp: Math.round((Date.now() / 1000)),
    entities: Array.from(collapsed_entities_set),
  };

  $.cookie('cb_reports_collapsed', JSON.stringify(collapsed_items),  { expires: 365, path: '/' });
}

async function init_report_script() {
  document.addEventListener('visibilitychange', function(e) {
    if(document.hidden){
      $('#jqContextMenu').hide();
    }
  });

  $('.date_param').datepicker({
    showOn: "button",
    dateFormat: lang.date_js_format,
    showAlways: true,
    buttonImage: 'images/calbtn.png',
    buttonImageOnly: true,
    buttonText: 'Calendar',
    showAnim: (('\v' == 'v') ? '' : 'show')  // в ie не включаем анимацию, тормозит
  }).attr('placeholder', lang.date_placeholder);

  showAAUpdatedLines();

  $('.input_element').each((i, el) => {
    $(el).find('select').on('change', (e) => {
      $(e.target).parents('.input_element').attr('changed', 'true');
    });

    $(el).find('input').on('change', (e) => {
      $(e.target).parents('.input_element').attr('changed', 'true');

      if ($(e.target).attr('datatype') == 'period') {
        $(e.target).parents('.input_element').attr('other_period', 'true');
      }
    });

    if ($('.input_element').length > 0) {
      if ($(el).attr('datatype') == 'period') {
        $(el).find('input').on('change', () => updateReport());
      } else {
        $(el).find('select').on('change', () => updateReport());
      }
    } else {
      if ($(el).attr('datatype') != 'period' && $('body').width() <= 480) {
        $(el).find('select').on('change', () => updateReport());
      }
    }
  });

  $('body').click(function (e) {
    if($(e.target).parents('.flexMenu-viewMore').length < 1 && !$(e.target).hasClass('flexMenu-viewMore')){
      $('.flexMenu-viewMore').removeClass('dropMenu__button--active');
      $('.flexMenu-viewMore').find('.flexMenu-popup').css('display', 'none');
    }
  });

  $('.repconview_params').find('select').each(_ => {
    init_chosen();
  });

  for(let item of document.querySelectorAll("input[type=checkbox][class=caption_checkbox]")) {
    item.onchange = function(){
      this.parentNode.classList.toggle("checked", this.checked);
    }
  }

  $('.repconview__layout').css('opacity','1');
  $('.loadi').remove();
  $('.preloader__block').remove();

  add_img_update($('.repconview__caption-params-info'));
  remove_class_update($('.repconview__caption-params-info'));
  remove_class_update_for_scroll($('.repconview__caption-params-info'));

  window.updateReport = updateReport;
}

function dropFlexMenu(el) {
  if($(el).find('.flexMenu-popup').css('display') == 'none'){
    $(el).addClass('dropMenu__button--active');
    $(el).find('.flexMenu-popup').css('display', 'block');
  }
  else {
    $(el).removeClass('dropMenu__button--active');
    $(el).find('.flexMenu-popup').css('display', 'none');
  }
}

function getChangedParams() {
  let params = [];
  let is_other_period = false;
  $('.input_element').each((i, el) => {
    if($(el).attr('changed') == 'true'){
      params.push($(el).attr('param_name'));
    }
    if($(el).attr('other_period') == 'true'){
      is_other_period = true;
    }
  });

  return {
    params: params.join('|'),
    is_other_period
  };
}

function generateParamsStr(use_changed_params = true) {
  let params_request_str = "";
  let changed_params = getChangedParams();

  let search_block_values = '';
  if (typeof window['search_block_values'] !== 'undefined') {
    for (let item in window['search_block_values']) {
      let value = window['search_block_values'][item];
      search_block_values = `&${item}=${value}`;
    }
  }

  $('.input_element').each(function (i, el) {
    let param_name = $(el).attr('param_name');
    let param_type = $(el).attr('datatype');

    if(param_type == 'period'){
      params_request_str += (param_name + '=' + $('#' + param_name + '_low').val() + '|' + $('#' + param_name + '_high').val() + '&');
    } else {
      params_request_str += (param_name + '=' + $('#' + param_name).val() + '&');
    }
  });

  params_request_str = params_request_str.slice(0, -1) + (use_changed_params ? '&changed_params=' + changed_params.params + (changed_params.is_other_period ? '&other_period=true' : '') : '');

  return params_request_str + (search_block_values == '' ? '' : `${search_block_values}`);
}

function exportExcel() {
  let params_request_str = generateParamsStr();

  let url = location.href + '&getexcel=getexcel&' + params_request_str;

  window.open(url, '_blank');
}

function exportPDF() {
  let params_request_str = generateParamsStr();
  let url = location.href + '&getpdf=getpdf&' + params_request_str;
  window.open(url, '_blank');
}

/**
 * Запросить с сервера и обновить отчет.
 * Фактически заменив innerHTML элемента rapps-root-report-view.
 *
 * @param {boolean} always  Принудительно обновить
 * @returns {void}
 */
function updateReport(always = false) {
  /**
   * Получить параметры сортировки.
   *
   * @returns {String}
   */
  function getSortOptions() {
    let sort_options = [];
    const sort_settings = JSON.parse(sessionStorage.getItem('sort_settings') || '{}');

    if (typeof sort_settings === 'object') {
      Object.keys(sort_settings).forEach(index => {
        let column_id = sort_settings[index]['column_id'] || '';
        let sorting_direction = sort_settings[index]['sorting_direction'] || 'asc';

        if (column_id != '') {
          sort_options.push({
            'block_id':  index,     // Идентификатор блока
            'column_id': column_id, // Идентификатор столбца
            'sorting_direction': sorting_direction // Направление сортировки
          });
        }
      });
    }

    return sort_options.length > 0
      ? ('&sort=' + encodeURIComponent(JSON.stringify(sort_options)))
      : '';
  }

  if (
    !always &&
    $("#btn-expansion-options").hasClass('repconview__btn-expansion-options_open')
  ) {
    return;
  }

  $('#jqContextMenu').hide();
  if($('body').width() > 990){
    $('.repconview__layout').prepend(create_preloader_block());
  }

  let params_request_str = generateParamsStr();
  let url = new URL(location.href);

  const sort_options = getSortOptions();
  const new_url = (
    url.pathname.indexOf('report_external.php') !== -1
  ) ? (
    url.origin + url.pathname
    + '?hash=' + (new URLSearchParams(window.location.search)).get('hash')
    + '&' + generateParamsStr(false)
  ) : (
    url.origin + url.pathname
    + '?id=' + (new URLSearchParams(window.location.search)).get('id')
    + '&' + generateParamsStr(false)
  );

  window.history.pushState(null, null, (new_url + sort_options));

  if (params_request_str.length > 0) {
    $.ajax({
      url: location.href + '&getdata=getdata&' + params_request_str + sort_options,
      success: function(layout) {
        $('#rapps-root-report-view').html(layout);
        $('.repconview__layout').prepend(`
          <div
            class="loadi"
            style="background: white;height:1000px;transition: all 0.2s linear 0s;"
          ></div>
        `);
        $('.repconview__layout').css({'transition': 'all 0.5s linear 0s', 'opacity':'0'});
        reportOnReady();

        startVueApplications();

        setTimeout(() => {
          init_report_script();
          const select2_plugin = $('.select2-plugin');
          select2_plugin.select2();
        }, 0);

        $('.repconview__table_table').fixedTable();
      }
    });
  }
}

function startVueApplications() {
  if (
    typeof window['search_block_values'] === 'undefined' ||
    typeof window['report_search_blocks'] === 'undefined'
  ) {
    return;
  }

  $('.repconview__layout div[id^=SRC]').each((_, item) => {
    let block_name = item.id;
    if (typeof window['report_search_blocks'][block_name] !== 'undefined') {
      CB.report.createSearchBlock(window['report_search_blocks'][block_name]);
    }
  });

  setTimeout(_ => $('.repconview__table_table').fixedTable(), 1000);
}

function changePeriod(el, period, is_increment) {
  let name_param = $(el).attr('id').split('_')[0];
  let low_param_value = $('#' + name_param + '_low').val();
  let high_param_value = $('#' + name_param + '_high').val();
  let format = lang.short_name == 'us' || lang.short_name == 'en'
    ? 'DD/MM/YYYY' : 'DD.MM.YYYY';

  let new_low_value = '';
  let new_high_value = '';

  let count_periods = $(el).parent('.repconview__param-inputs').attr('count_periods') || 1;
  let add_param = is_increment ? count_periods : (-1 * count_periods);

  new_low_value = moment(low_param_value, 'DD.MM.YYYY').add(add_param, period).format(format);
  if (period == 'month') {
    new_high_value = moment(high_param_value, 'DD.MM.YYYY').add(add_param, period).endOf('month').format(format);
  } else {
    new_high_value = moment(high_param_value, 'DD.MM.YYYY').add(add_param, period).format(format);
  }

  if (new_low_value == low_param_value || new_high_value == high_param_value) {
    // если переключаемся на февраль с марта, то минус 13 дней от периода
    let day_count = (moment(low_param_value, 'DD.MM.YYYY').format('MM')=='03' && !is_increment) ? 13 : 15;
    let temp = moment(low_param_value, 'DD.MM.YYYY').add(add_param * day_count + 1, 'day');
    if (temp.date()<=15) {
      new_low_value = temp.startOf('month').format(format);
      new_high_value = temp.date(15).format(format);
    } else {
      new_low_value = temp.date(16).format(format);
      new_high_value = temp.endOf('month').format(format);
    }
  }

  $('#' + name_param + '_low').parents('.input_element').attr('changed', 'true');
  $('#' + name_param + '_low').val(new_low_value);
  $('#' + name_param + '_high').val(new_high_value);

  // Если пользователь нажал на иконку, раскрыть все параметры,
  // то перезагрузка происходит, только по нажатию кнопки "Обновить",
  // как при изменении первого параметра, так и остальных.
  if ($("#btn-expansion-options").hasClass('repconview__btn-expansion-options_open')) {
    return;
  } else {
    updateReport();
  }
}

function changeProgressBarValue(el, _value, animate = false) {
  let value = parseFloat(animate ? el.attr('progress-value') : _value);
  el.find('.progress_bar__value').text(value.toString().replace('.', ','));
  el.find('#left_chunk').css('transform', 'rotate('+ (3.6 * value) +'deg)');

  if(value >= 50) {
    el.find('.progress_bar').css('clip', 'rect(auto, auto, auto, auto)');
    el.find('#right_chunk').css({
      'display': 'block',
      'transform': 'rotate(180deg)',
    });
  }

  if(animate){
    el.attr('progress-value', ((value + 1) > _value && value < _value ? _value : (value + 1)));
    if(value != _value){
      setTimeout(() => {
        changeProgressBarValue(el, _value, true);
      }, 25);
    }
  }
}

/**
 * Функция инициализирует скрытие/показ параметров в отчетах
 *
 * @returns {void}
 */
function additionalReportOptions() {
  let topOption = $('.report__title .input_element');
  let additionalOptions = $('.repconview_params');

  if (topOption.length === 1 && additionalOptions.length === 1) {
    let btnExpansionOptions = `<span id='btn-expansion-options' class="repconview__btn-expansion-options" onclick="btnShowOptions(this)"></span>`;
    topOption[0].insertAdjacentHTML('beforeend', btnExpansionOptions);

    let status = false;
    status = artificeWithStorage();

    let selectOptions = $('.repconview_params .input_element .repconview__param-inputs select[id^=P]');
    for (let i = 0; selectOptions.length > i; i++) {
      if (selectOptions[i].value != '') {
        status = true;
        break;
      }
    }

    showAdditionalOptions(status);
  }
}

/**
 * @param status
 * @returns visibility = show/hide в localStorage['report_expansion']
 */
function btnShowOptions(btn) {
  let localPeriodData = JSON.parse(localStorage.getItem('report_expansion'));

  if ($(btn).is('.repconview__btn-expansion-options_open')) {
    // hide
    localPeriodData['visibility'] = 'hide';
  } else {
    // open
    localPeriodData['visibility'] = 'open';
  }

  localStorage.setItem('report_expansion', JSON.stringify(localPeriodData));
  showAdditionalOptions(true);
}

/**
 * Вся функция связана на localStorage и параметров в URL
 * Возвращает true/false
 */
function artificeWithStorage() {
  let urlData = window.location.search;

  // Если переключали период
  if (urlData.search('P1') > 0) {
    let periodList = JSON.parse(localStorage.getItem('report_expansion'));
    if (periodList === null) {
      writeInStorage();
      periodList = JSON.parse(localStorage.getItem('report_expansion'));
    }

    // достаем id отчета из url
    let reportId = new URL(window.location.href).searchParams.get('id');
    let urlParams = window.location.search;

    for (let key in periodList[reportId]) {
      // вернет P__
      let attrP = key.split('_', 1);
      let sequence = key.split('_', 2)[1];

      // Позволяет достать данные конкретного периода по url
      let urlPeriod = urlParams.split(attrP + '=', 2)[1].split("&", 1)[0];

      let num = (sequence.includes('low')) ? 0 : 1;

      if (periodList[reportId][key] !== urlPeriod.split('|')[num]) {
        return true;
      }
    }
  } else {
    // При первом открытии отчета записываем значения в localStorage
    writeInStorage();
  }
}

/**
 * записывает значения полей даты
 * записывает в localStorage ключом report_expansion
 */
function writeInStorage() {
  let dateInputs = $('.repconview_params .input_element[datatype="period"] .date_param[datatype="period"]');
  let dataInputsList = {};

  dateInputs.each(function(i, elem) {
    let idInput = elem.getAttribute('id');
    dataInputsList[idInput] = elem.value;
  })

  let reportId = new URL(window.location.href).searchParams.get('id');
  let currentPeriodList = {};
  currentPeriodList[reportId] = dataInputsList;

  localStorage.removeItem('report_expansion');
  localStorage.setItem('report_expansion', JSON.stringify(currentPeriodList));
}

function showAdditionalOptions(status) {
  let localPeriodData = JSON.parse(localStorage.getItem('report_expansion'));
  let localVisibility = localPeriodData['visibility'];

  // в приоритете статус open/hide по кнопке
  if (localVisibility !== undefined && localVisibility !== null) {
    let btnExpansOptions = $('.repconview__btn-expansion-options');
    let additionalOptions = $('.repconview_params');

    if (localVisibility === 'open') {
      if (!$(btnExpansOptions[0]).is('.repconview__btn-expansion-options_open')) {
        btnExpansOptions[0].classList.add('repconview__btn-expansion-options_open');
      }
      if ($(additionalOptions[0]).is('.repconview_params_close')) {
        additionalOptions[0].classList.remove('repconview_params_close');
      }
    } else if (localVisibility === 'hide') {
      if ($(btnExpansOptions[0]).is('.repconview__btn-expansion-options_open')) {
        btnExpansOptions[0].classList.remove('repconview__btn-expansion-options_open');
      }
      if (!$(additionalOptions[0]).is('.repconview_params_close')) {
        additionalOptions[0].classList.add('repconview_params_close');
      }
    }
  } else if (status) {
    let btnExpansOptions = $('.repconview__btn-expansion-options');
    btnExpansOptions[0].classList.toggle('repconview__btn-expansion-options_open');

    let additionalOptions = $('.repconview_params');
    additionalOptions[0].classList.toggle('repconview_params_close');
  }
}

/**
 * Сформировть сортировку в блоке.
 *
 * @param {String} block_id             Идентификатор блока
 * @param {String} column_id            Идентификатор столбца
 * @param {String} sorting_direction    Направление сортировки
 * @returns {void}
 */
function buildSortingInBlock(block_id, column_id, sorting_direction) {
  /**
   * Получить настройки сортировки.
   *
   * @returns {Object}
   */
  function getSortSettings() {
    const settings = sessionStorage.getItem('sort_settings');

    if (settings == null) {
      saveSortSettings({});
      return getSortSettings();
    }

    return JSON.parse(settings);
  }

  /**
   * Сохранить  настройки сортировки.
   *
   * @param {Object} settings
   * @returns {void}
   */
  function saveSortSettings(settings) {
    sessionStorage.setItem('sort_settings', JSON.stringify(settings));
  }

  const sort_settings = getSortSettings();

  if ( // по данному блоку нет настроек сортировки
    typeof sort_settings[block_id] === 'undefined'
  ) {
    sort_settings[block_id] = { 'column_id': '', 'sorting_direction': '' };
  }

  sort_settings[block_id]['column_id'] = column_id;
  switch (sorting_direction) {
    case '':
      sort_settings[block_id]['sorting_direction'] = 'asc';
      break;

    case 'asc':
      sort_settings[block_id]['sorting_direction'] = 'desc';
      break;

    case 'desc':
      delete sort_settings[block_id];
      break;
  }

  saveSortSettings(sort_settings);
  updateReport(true);
}
